﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;
using System.Xml;

using C1.C1Report;
using System.Data;

namespace CreateReport
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        private C1Report c1r;
       
        public Window1()
        {
            InitializeComponent();
        }

        private void RenderReport()
        {
            c1r = new C1Report();
            Field f;
            Section s;
            Layout l = this.c1r.Layout;
            l.Orientation = OrientationEnum.Portrait;
            l.Width = 6.5 * 1440; // 8.5 - margins
            string addfunction = 
                "lSeconds = DateDiff(\"s\", Time1, Time2)\r\n" +
            "add_time=add_time+lSeconds\r\n" +
            "lHrs = Int(lSeconds / 3600)\r\n" +
            "lMinutes = (Int(lSeconds / 60)) - (lHrs * 60)\r\n"+
            "lSeconds = Int(lSeconds Mod 60)\r\n"+
            "If lSeconds = 60 Then\r\n"+
            "lMinutes = lMinutes + 1\r\n"+
            "lSeconds = 0\r\n"+
            "End If\r\n"+
            "If lMinutes = 60 Then\r\n"+
            "lMinutes = 0\r\n"+ 
            "lHrs = lHrs + 1\r\n"+ 
            "End If\r\n"+
            "diff_time = lHrs & \":\" & lMinutes &  \":\" & lSeconds";
            this.c1r.ReportName = "TimeSpan_Sum";
          
           // this.c1r.DataSource.ConnectionString=@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Users\stduser\Documents\ComponentOne Samples\Common\C1NWind.mdb;Persist Security Info=False";
         //   this.c1r.DataSource.RecordSource = "PRODUCTS";
            c1r.OnOpen =
                "diff_time =\"\"" + "\r\n" +
              "add_time=0"; 
            s = this.c1r.Sections[SectionTypeEnum.Header];
            s.Visible = true;
            f = s.Fields.Add("titleLbl", "Test Report", 50, 200, 9360, 600);
            f.Visible = true;
            f.Font.Size = 20;
            f.Font.Bold = true;

            Group grp = this.c1r.Groups.Add("GrpCategory", "", SortEnum.Ascending);            
            s = grp.SectionHeader;            
            s.Visible = true;
            f = s.Fields.Add("Time1Ctl", "Time1",1000, 250, 600, 350);
            f.Visible = true;            
                        
            f = s.Fields.Add("Time2Ctl", "Time2",2000, 250, 600, 350);
            f.Visible = true;

            f = s.Fields.Add("Time3Ctl", "Difference between times", 3000, 250, 7000, 350);
            f.Visible = true;
         
                    

            s = this.c1r.Sections[SectionTypeEnum.Detail];
            s.Visible = true;
           

 
            f = s.Fields.Add("Time1Lbl", "Time1", 1000, 550, 1200, 200);
            f.Format = "Long Time"; 
            f.Calculated = true; 
            f.Visible = true;

            f = s.Fields.Add("Time2Lbl", "Time2", 2000, 550, 1200, 200);
            f.Format = "Long Time"; 
            f.Calculated = true; 
            f.Visible = true;

            f = s.Fields.Add("Time3Lbl", "diffintimes", 3000, 550, 1200, 200);
            f.Calculated = true;
            f.Text = "diff_time"; 
           
            f.Visible = true;

            s.OnFormat = addfunction; 

            s = grp.SectionFooter;
            s.Visible = true;
           
            f = s.Fields.Add("Field1", "Total Time", 1500, 700, 1550, 345);
            f.Visible = true;

            f = s.Fields.Add("Field2", "", 3000, 700, 930, 300);
            f.Text = "diff_time"; 
            f.Visible = true;
            f.Calculated = true;
            s.OnFormat =
          "lSeconds = add_time\r\n" +
            "lHrs = Int(lSeconds / 3600)\r\n" +
            "lMinutes = (Int(lSeconds / 60)) - (lHrs * 60)\r\n" +
            "lSeconds = Int(lSeconds Mod 60)\r\n" +
            "If lSeconds = 60 Then\r\n" +
            "lMinutes = lMinutes + 1\r\n" +
            "lSeconds = 0\r\n" +
            "End If\r\n" +
            "If lMinutes = 60 Then\r\n" +
            "lMinutes = 0\r\n" +
            "lHrs = lHrs + 1\r\n" +
            "End If\r\n" +
            "diff_time = lHrs & \":\" & lMinutes &  \":\" & lSeconds";

            s = this.c1r.Sections[SectionTypeEnum.PageFooter];
            s.Visible = true;
            f = s.Fields.Add("ftrLeft", "Now()",50, 30, 4680, 300);
            f.Calculated=true;
            f.Visible = true;

            f = s.Fields.Add("ftrRight", @"""Page "" & Page & "" of "" & Pages", 7680, 30, 4680, 300);
            f.Calculated = true;
            f.Visible = true;


            DataTable dt = new DataTable(); 
            dt.Columns.Add("Time1",typeof(DateTime));
            dt.Columns.Add("Time2", typeof(DateTime));

           // add some test values
            dt.Rows.Add(DateTime.Now.AddSeconds(367), DateTime.Now.AddSeconds(469));
            dt.Rows.Add(DateTime.Now.AddSeconds(341), DateTime.Now.AddSeconds(575));

            c1r.DataSource.Recordset = dt;  
            c1DocumentViewer1.Document = c1r.C1Document.FixedDocumentSequence;
        }

        

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            c1r = new C1Report();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                Cursor = Cursors.Wait;
                RenderReport();
            }
            finally
            {
                Cursor = Cursors.Arrow;
            }
        }

       
    }
}
